"""SSLAbsoluteURL module"""

__version__='$Revision: 1.3 $'[11:-2]

from OFS.Application import Application
from OFS.Traversable import Traversable

def absolute_url(self, relative=0):
    """SSL-aware absolute_url()"""
	
    url = self.__orig_absolute_url(relative)

    try: ssl = self.aq_acquire('SSL')
    except AttributeError: return url
    
    try: forceon = self.aq_acquire('SSLForceOn')
    except AttributeError: forceon = None
    
    try: forceoff = self.aq_acquire('SSLForceOff')
    except AttributeError: forceoff = None

    if not relative:
	if forceon or (ssl and not forceoff):
	    if url[4] != 's':
		url = "https" + url[4:]
	elif forceoff or not ssl:
	    if url[4] == 's':
		url = "http" + url[5:]

    return url

Application.__orig_absolute_url = Application.absolute_url
Application.absolute_url = absolute_url
Traversable.__orig_absolute_url = Traversable.absolute_url
Traversable.absolute_url = absolute_url
